<script lang="ts">
import { computed, ComputedRef, defineComponent, reactive, ref } from '@vue/composition-api'
import { getConnection } from '@/plugins/connect'
import { Msg, StringCodec } from "nats.ws"
import strftime from 'strftime';
import { EPNMessage } from '@/model';

interface Message {
	subject: string,
	msg: EPNMessage,
	timestamp?: Date
}

export default defineComponent({
	name: "MessageLog",
	components: {

	},
	props: {
		value: {
			type: Number,
			default: 0,
		},
	},
	setup(props, { root }) {
		
		var msglist = ref([] as Msg[]);
		var times = ref([] as Date[]);

		var sc = StringCodec();
		var messages: ComputedRef<Message[]> = computed(() =>
			msglist.value.map((item, i) => ({ subject: item.subject, msg: JSON.parse(sc.decode(item.data as Uint8Array)), timestamp: times.value[i] as Date }))
		)
		//var messages: Message[] = [{ subject: "printer.job", payload: "anyad", timestamp: new Date() }, { subject: "kekw", payload: "dfad" }, { subject: "printer.job", payload: "anyad" }, { subject: "kekw", payload: "dfad" }, { subject: "printer.job", payload: "anyad" }, { subject: "kekw", payload: "dfad" }, { subject: "printer.job", payload: "anyad" }, { subject: "kekw", payload: "dfad" }, { subject: "printer.job", payload: "anyad" }, { subject: "kekw", payload: "dfad" }, { subject: "printer.job", payload: "anyad" }, { subject: "kekw", payload: "dfad" }]

		getConnection().then(async (nc) => {
			if (nc) {
				var sub = nc.subscribe(">");
				for await (const msg of sub) {
					console.log(msg)
					msglist.value.unshift(msg);
					times.value.unshift(new Date());
				}
			} else {
				console.log("Kaga");
			}
		}
		);

		const minute = (date: Date) => strftime("%H:%M", date);

		return { messages, msglist, times, minute };
	},
})
</script>

<template>
	<div class="wrapper">
		<div class="text-button">
			<v-icon>mdi-message-text</v-icon>
			Message log
		</div>
		<v-divider></v-divider>

		<transition-group name="list" tag="div" class="msgs" mode="in-out">
			<div v-for="m in messages" :key="m.timestamp + m.msg.code" class="message">
				<!-- <div class="clock text-h6" v-if="msg.timestamp">{{minute(msg.timestamp)}}</div> -->
				<div class="clock text-h6">{{minute(m.timestamp)}}</div>
				<div class="overline message-subject">
					{{m.subject}}
				</div>
				<div class="subtitle message-payload">
					{{m.msg.code}} - {{m.msg.state}}
				</div>
				<div v-if="m.msg.payload">
					{{m.msg.payload}}
				</div>
				<v-divider class="divider"></v-divider>
			</div>
		</transition-group>
	</div>
</template>

<style scoped>
.list-enter-active, .list-leave-active{
	transition: all .5s;
}
.list-enter, .list-leave-to{
	opacity: 0;
}
.list-move {
  transition: transform 0.5s;
}
.clock {
	grid-row: 1/3;
	grid-column: 1/2;
	text-align: center;
}
.message-subject {
	grid-row: 1/2;
	grid-column: 2/3;
}
.message-payload {
	grid-row: 2/3;
	grid-column: 2/3;
}
.divider {
	grid-row: 3/4;
	grid-column: 1/3;
}
div {
	margin: 0.2em;
	padding: 0.1em;
}
.message {
	display: grid;
	align-items: center;
	grid-template-columns: 5em 1fr;
	grid-template-rows: 1fr 1fr 0.3fr;
}
.v-card {
	overflow-y: scroll;
}
.wrapper {
	height: calc(100vh - 64px);
	display: flex;
	flex-flow: column;
}
.msgs {
	overflow-y: scroll;
	flex-grow: 1;
}
</style>